<?php

/**
 * @file
 * Contains \Drupal\forward\Controller\ForwardController.
 */

namespace Drupal\forward\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Entity\EntityInterface;


/**
 * Returns responses for the Forward module.
 */
class ForwardController extends ControllerBase {

  /**
   * Build a Forward form when accessed as a separate page through the router.
   *
   * @param \Symfony\Component\HttpFoundation\Request $request
   *   The request of the page.
   * @param EntityInterface $entity
   *   The entity being forwarded.
   *
   * @return array
   *   The render array for the form.
   */
  public function buildForm(EntityInterface $entity) {
    $config = \Drupal::configFactory()->getEditable('forward.settings');
    // Force the "link" interface so the Forward form page doesn't build inside a fieldset
    $config->set('forward_interface_type', 'link');
    $settings = $config->get();
    return \Drupal::service('forward.form_builder')->buildForwardEntityForm($entity, $settings);
  }
}
