<?php

/**
 * @file
 * Contains \Drupal\forward\ForwardFormBuilder.
 */

namespace Drupal\forward;

use Drupal\Core\Entity\EntityInterface;
use Drupal\forward\Form\ForwardForm;

/**
 * Defines a class for building markup for a Forward inline form on an entity.
 */
class ForwardFormBuilder implements ForwardFormBuilderInterface {

  /**
   * {@inheritdoc}
   */
  public function buildForwardEntityForm(EntityInterface $entity, array $settings) {
    $form = new ForwardForm($entity);
    $render_array = \Drupal::formBuilder()->getForm($form, $settings);
    $render_array['#weight'] = $settings['forward_interface_weight'];
    return $render_array;
  }
}
