<?php

/**
 * @file
 * Contains \Drupal\forward\Plugin\DsField\ForwardForm.
 */

namespace Drupal\forward\Plugin\DsField;

use Drupal\ds\Plugin\DsField\DsFieldBase;

/**
 * Forward form plugin.
 *
 * @DsField(
 *   id = "forward_form",
 *   title = @Translation("Forward form"),
 *   entity_type = "node"
 * )
 */
class ForwardForm extends DsFieldBase {
  protected $settings;

  /**
   * Constructs a Display Suite field plugin.
   */
  public function __construct($configuration, $plugin_id, $plugin_definition) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    $config = \Drupal::configFactory()->getEditable('forward.settings');
    // Force the "form" interface
    $config->set('forward_interface_type', 'form');
    $this->settings = $config->get();
  }

  /**
   * {@inheritdoc}
   */
  public function isAllowed() {
    return \Drupal::service('forward.access_checker')->isAllowed($this->settings, $this->entity(), $this->viewMode(), $this->getEntityTypeId(), $this->bundle());
  }

  /**
   * {@inheritdoc}
   */
  public function build() {
    $render_array = array();

    // Build the form unless Forward is rendering an email
    $config = $this->getConfiguration();
    if (empty($config['build']['#forward_build'])) {
      $render_array = \Drupal::service('forward.form_builder')->buildForwardEntityForm($this->entity(), $this->settings);
    }

    return $render_array;
  }
}
