<?php

/**
 * @file
 * Definition of Drupal\forward\Plugin\views\field\ForwardLink
 */

namespace Drupal\forward\Plugin\views\field;

use Drupal\Core\Form\FormStateInterface;
use Drupal\views\Plugin\views\field\FieldPluginBase;
use Drupal\views\ResultRow;

/**
 * Field handler to flag the node type.
 *
 * @ingroup views_field_handlers
 *
 * @ViewsField("forward_link")
 */
class ForwardLink extends FieldPluginBase {

  /**
   * @{inheritdoc}
   */
  public function query() {
    // Leave empty to avoid a query on this field.
  }

  /**
   * Define the available options
   * @return array
   */
  protected function defineOptions() {
    $options = parent::defineOptions();

    return $options;
  }

  /**
   * @{inheritdoc}
   */
  public function render(ResultRow $values) {
    $config = \Drupal::configFactory()->getEditable('forward.settings');
    // Force standard render
    $config->set('forward_link_inline', FALSE);
    $settings = $config->get();
    // Views fields do not have a view mode, so skip that in the access check
    $view_mode = FALSE;
    if (\Drupal::service('forward.access_checker')->isAllowed($settings, $values->_entity, $view_mode)) {
      return \Drupal::service('forward.link_builder')->buildForwardEntityLink($values->_entity, $settings);
    }
  }
}
